'
'  **************************************************
'  *                                                *
'  *                    ASIN.BAS                    *
'  *                                                *
'  *          Calculate ArcSine Function 1.0        *
'  *                                                *
'  *              Judson D. McClendon               *
'  *              Sun Valley Systems                *
'  *              4522 Shadow Ridge Pkwy            *
'  *              Pinson, AL 35126-2192             *
'  *                 205-680-0460                   *
'  *                                                *
'  **************************************************
'
DEFDBL A-Z
PRINT "Compute ASIN(X)"
INPUT "Enter X: ", X

PRINT USING "##.###############"; 2 * ATN(X / (1 + SQR(1 - X * X)))

PI = 3.14159265358979#

SIGN = 1#
IF (X < 0) THEN
   X = -X
   SIGN = -1#
END IF

IF (X = 0) THEN
   ASIN = 0#
ELSEIF (X = 1) THEN
   ASIN = PI / 2
ELSE
   SX = X
   CX = SQR(1# - X * X)
   GOSUB RESOLVE
   ASIN = ANGLE
END IF
   
ASIN = ASIN * SIGN

PRINT USING "##.###############"; ASIN

END


RESOLVE:
   DIF = 0#

   S1 = SIN(.1#)        ' Scale The Argument
   C1 = COS(.1#)
   WHILE (SX > S1)
      DIF = DIF + .1#
      NSX = SX * C1 - CX * S1
      NCX = CX * C1 + SX * S1
      SX = NSX
      CX = NCX
   WEND

   S1 = SIN(.01#)
   C1 = COS(.01#)
   WHILE (SX > S1)
      DIF = DIF + .01#
      NSX = SX * C1 - CX * S1
      NCX = CX * C1 + SX * S1
      SX = NSX
      CX = NCX
   WEND

   S1 = SIN(.001#)
   C1 = COS(.001#)
   WHILE (SX > S1)
      DIF = DIF + .001#
      NSX = SX * C1 - CX * S1
      NCX = CX * C1 + SX * S1
      SX = NSX
      CX = NCX
   WEND


   X = SX / CX
   XSQ = X * X
   Y = XSQ / (1 + XSQ)
   TERM = 1
   SUM = 1
   N = 0

   DO
      N = N + 2

      TERM = (TERM * N * Y) / (N + 1)
       
      LASTSUM = SUM
      SUM = SUM + TERM
   LOOP WHILE (SUM <> LASTSUM)
 
   ANGLE = SUM * Y / X + DIF

   RETURN

